<?php 
	define('CURRENT_DIR',    'quicklinker/');
	define('LINK_LIST_FILE', 'link.csv');
	define('SETUP_FILE', 'setting.csv');
	define('BASE_FILE', 'base.html');
	define('LINK_PAGE_FILE1', 'link.html');
	define('LINK_PAGE_FILE2', 'link2.html');
	define('LINK_PAGE_FILE3', 'link3.html');
	define('NO_DATA_IMG_PATH', '');
	define('NO_DATA_IMG_WIDTH', 0);
	define('NO_DATA_IMG_HEIGHT', 0);
	define('LOGICRAFT','http://logicraft.jis.click/?l1');
	define('POWERD_BY','<div class="quicklinker_link_log"><a href="'.LOGICRAFT.'" target="_blank">powered by LOGICRAFT</a></div>'."\n");
	date_default_timezone_set('Asia/Tokyo');
	function exchange_char(){
	// *********************************************************************
	// -- 説明 --
	// 文字列内のメタ文字をエスケープ文字に変換する。複数の引数を使って複合処理が可能。
	// -- バージョン --
	// v1.01
	// -- 動作環境 --
	// PHP 4.1.0以降
	// -- 引数 --
	// $args(0)		変換する文字列
	// $args(0以外)  ステータス -> HTML CSV REVERSE 等
	// -- デフォルト --
	// エンコード：UTF-8
	// -- 引数の値ごとの処理 --
	// HTML = HTMLメタ文字をエスケープ文字に変換 < > " ' &
	// CSV = CSVメタ文字をエスケープ文字に変換 , 改行コード
	// XML = 半角&を全角＆に変換
	// BR = 改行コードを<br>に変換
	// REVERSE = 指定した全てのエスケープ文字をメタ文字に変換
	// EUCJP = エンコードをEUCJPにする（引数にHTMLを入れているときのみ有効）
	// SJIS = エンコードをSJISにする（引数にHTMLを入れているときのみ有効）
	// UTF-8 = エンコードをUTF-8にする（引数にHTMLを入れているときのみ有効）
	// URL =
	//
	// -- 更新履歴 --
	// 2014.6.24 制作 LOGICRAFT T.Y
	// 2014.6.27 更新 LOGICRAFT T.Y ... 引数BRを追加
	//
	// *********************************************************************
		$args=func_get_args();
		
		$encode="UTF-8";
		
		$flag_html=false;
		$flag_csv=false;
		$flag_BR=false;
		$flag_XML=false;
		$flag_rXML=false;//あとにまわす処理フラグ
		$flag_REVERSE=false;
		$string=false;
		$cnt=0;
		foreach($args as $value){
			if($cnt==0){
				$string=$value;
			}else{
				if($value=='HTML'){
					$flag_html=true;
				}
				if($value=='CSV'){
					$flag_csv=true;
				}
				if($value=='XML'){
					$flag_XML=true;
				}
				if($value=='BR'){
					$flag_BR=true;
				}
				if($value=='REVERSE'){
					$flag_REVERSE=true;
				}
				if($value=='EUCJP'){
					$encode="EUC-JP";
				}
				if($value=='SJIS'){
					$encode="Shift_JIS";
				}
				if($value=='UTF-8'){
					$encode="UTF-8";
				}
			}
			$cnt++;
		}
		if(($flag_XML==true)&&($flag_REVERSE==true)){
			$flag_rXML=true;
		}elseif($flag_XML==true){
			$string=str_replace('&','＆',$string);
		}
		if(($flag_html==true)&&($flag_REVERSE==true)){
			$string=htmlspecialchars_decode($string,ENT_QUOTES);
		}elseif($flag_html==true){
			$string=htmlspecialchars($string,ENT_QUOTES,$encode);
			$string=str_replace('&amp;','&',$string);
		}
		if(($flag_csv==true)&&($flag_REVERSE==true)){
			$string=str_replace('&#44;',',',$string);
			$string=str_replace("<br>","\n",$string);
		}elseif($flag_csv==true){
			$string=str_replace(',','&#44;',$string);
			$string=str_replace("\r\n","<br>",$string);
			$string=str_replace("\r","<br>",$string);
			$string=str_replace("\n","<br>",$string);
		}
		if(($flag_BR==true)&&($flag_REVERSE==true)){
			$string=str_replace("<br>","\n",$string);
		}elseif($flag_BR==true){
			$string=str_replace("\r\n","<br>",$string);
			$string=str_replace("\r","<br>",$string);
			$string=str_replace("\n","<br>",$string);
		}
		// あとにまわした処理の解決
		if($flag_rXML==true){
			$string=str_replace('＆','&',$string);
		}
		// 値を返す
		return $string;
	}
	function arrayGetCsv($filename,$column=false){
	/*-------------------------------------------------------------------
	-- 機能 --
	二次元配列データをCSVファイルから読み込む。
	 保存時に排他処理を行う。
	 デリミタ、エンクロージャを含む文字列をエスケープする。
	 =二次元配列の内容例=
	 $data = array(array( "1", "hoge", "hogegege..." ),
				   array( "2", "fuga", "gugagaga..." ),
				   array( "3", "piyo", "piyoyoyo..." ));
	-- バージョン --
	v1.01
	-- 動作環境 --
	PHP 5
	-- 引数 --
	$filename		:読込先パス・ファイル名
	$column			:カラム数の指定
	-- 返り値 --
	読み込んだデータの二次元配列を返します。失敗した場合にfalseを返します。
	-- 更新履歴 --
	2014.11.28 制作 LOGICRAFT T.Y
    2015.04.17 更新 LOGICRAFT T.Y マルチバイト文字が消えるバグ対策の追加
	-------------------------------------------------------------------*/
		$filemode='r';
		$length=0;
		$delim=',';
		$enclosure='"';
		$ret=false;
		try{
            setlocale(LC_ALL, 'ja_JP.UTF-8');
			$fp=@fopen($filename,$filemode);
			if($fp){
				while(($buff=fgetcsv($fp,$length,$delim,$enclosure))!==false){
					if($column!==false){
						for($i=0;$i<=$column;$i++){
							if(!isset($buff[$i])){
								$buff[$i]=null;
							}
						}
					}
					$arraydata[]=$buff;
				}
				if(!empty($arraydata)){
					$ret=$arraydata;
				}
			}
		}catch(Exception $e){
			$ret=false;
		}
		return $ret;
	}
	function arrayPutCsv($filename,$arraydata){
	/*-------------------------------------------------------------------
	-- 機能 --
	二次元配列データをCSVファイルに保存する。
	 保存時に排他処理を行う。
	 デリミタ、エンクロージャを含む文字列をエスケープする。
	 =二次元配列の内容例=
	 $data = array(array( "1", "hoge", "hogegege..." ),
				   array( "2", "fuga", "gugagaga..." ),
				   array( "3", "piyo", "piyoyoyo..." ));
	-- バージョン --
	v1.00
	-- 動作環境 --
	PHP 5
	-- 引数 --
	$filename		:保存先パス・ファイル名
	$ArrayData		:保存するデータ（二次元配列） 一次元=row 二次元=column
	-- 返り値 --
	書き込んだ文字列の長さを返します。失敗した場合にfalseを返します。
	また$arraydataが空データの場合は、保存を行わずにfalseを返す。
	-- 更新履歴 --
	2014.11.28 制作 LOGICRAFT T.Y
	-------------------------------------------------------------------*/
		$filemode='w';
		$delim=',';
		$enclosure='"';
		$ret=false;
		if($arraydata!==null){
			$fp=@fopen($filename,$filemode);
			if($fp){
				if(flock($fp, LOCK_EX)){
					foreach($arraydata as $rowdata){
						$ret=@fputcsv($fp,$rowdata,$delim,$enclosure);
					}
					flock($fp,LOCK_UN);
				}		
				fclose($fp);
			}
		}
		return $ret;
	}
	function getFeedData($feed_url,$feed_type=1,$feed_article_page=0,$min_width=120,$min_height=90,$no_img='',$no_img_width=0,$no_img_height=0){
	/*-------------------------------------------------------------------
	-- 機能 --
	feedデータ（RSS、Atom）を取得する。
	-- バージョン --
	v1.01
	-- 動作環境 --
	PHP 5
	-- 引数 --
	$feed_url			:feed取得先url
	$feed_type			:feed方法  0=feedしない 1=画像有でfeedする 2=画像なしでfeedする
	$feed_article_page	:feedする記事のページ
	$min_width			:取得する記事の画像、最低幅
	$min_height			:取得する記事の画像、最低高さ
	$no_img				:画像がない場合に差し込む画像 （デフォルト:画像なし）
	$no_img_width		:画像がない場合に差し込む画像 横幅
	$no_img_height		:画像がない場合に差し込む画像 高さ
	-- 返り値 --
	読み込んだfeedデータを配列で返します。失敗した場合にfalseを返します。
	 =配列の内容=
	   $array('time',	取得した日時（unixタイムスタンプ）
			  'url',	サイトのURL
			  'site'	サイト名
			  'link'	記事のURL
			  'title'	記事のタイトル
			  'pub'		記事の公開日時（unixタイムスタンプ）
			  'image'	記事の画像
			  'width'	記事の画像の幅 x
			  'height')	記事の画像の高さ y
				  
	-- 更新履歴 --
	2014.12.02 制作 LOGICRAFT T.Y
	2015.02.27 更新 LOGICRAFT T.Y descriptionに画像がない場合、contentに探しに行っていなかった不具合の修正
	-------------------------------------------------------------------*/
		if(!empty($feed_url) && ($feed_type!=0)){
			$rss_data = @simplexml_load_file($feed_url);
			if($rss_data){
				$rss_base_data=array();
				if (isset($rss_data->channel->title)) {
					$rss_base_data['title'] = $rss_data->channel->title;
					$rss_base_data['link']  = $rss_data->channel->link;
				} else {
					$rss_base_data['title'] = $rss_data->title;
					$rss_base_data['link']  = $rss_data->link['href'];
				}
				$rss_load_data=array();
				//Atom用の処理
				if($rss_data->entry){
					foreach ($rss_data->entry as $item) {
						$article_data = array();
						$article_data['link'] = (string)$item->link->attributes()->href;
						$article_data['title'] = (string)$item->title;
						$article_data['description'] = (string)$item->content;
						$article_data['content'] = '';
						if(isset($item->issued)){
							$article_data['pub'] = (string)$item->issued;
						}elseif(isset($item->published)){
							$article_data['pub'] = (string)$item->published;
						}else{
							$article_data['pub'] = (string)$item->updated;
						}
						$rss_load_data[] = $article_data;
					}
				//RSS1.0用の処理
				}elseif($rss_data->item){
					foreach ($rss_data->item as $item) {
						$article_data = array();
						$article_data['link'] = (string)$item->link;
						$article_data['title'] = (string)$item->title;
						$article_data['description'] = (string)$item->description;
						$article_data['content'] = (string)$item->children('http://purl.org/rss/1.0/modules/content/');
						$article_data['pub'] = (string)$item->children('http://purl.org/dc/elements/1.1/')->date;
						$rss_load_data[] = $article_data;
					}
				//RSS2.0用の処理
				}elseif($rss_data->channel->item){
					foreach ($rss_data->channel->item as $item) {
						$article_data = array();
						$article_data['link'] = (string)$item->link;
						$article_data['title'] = (string)$item->title;
						$article_data['description'] = (string)$item->description;
						$article_data['content'] = (string)$item->children('http://purl.org/rss/1.0/modules/content/');
						$article_data['pub'] = (string)$item->pubDate;
						$rss_load_data[] = $article_data;
					}
				}
				if(!empty($rss_load_data[$feed_article_page]['link'])){
					$ret['time']=time();
					$ret['url']=$rss_base_data['link'];
					$ret['site']=$rss_base_data['title'];
					$ret['link']=$rss_load_data[$feed_article_page]['link'];
					$ret['title']=$rss_load_data[$feed_article_page]['title'];
					$ret['pub']=$rss_load_data[$feed_article_page]['pub'];
					$ret['image']=$no_img;
					$ret['width']=$no_img_width;
					$ret['height']=$no_img_height;
					if($feed_type!=2){
						if(!empty($rss_load_data[$feed_article_page]['description'])){
							if(preg_match_all('#(http[^\s]*\.(jpg|jpeg|gif|png|bmp))|<img src="(.*?)"#',$rss_load_data[$feed_article_page]['description'],$match)){
								for($i=0;$i<count($match[0]);$i++){
                                    if(!empty($match[1][$i])){
                                        $extracted_img=$match[1][$i];
                                    }elseif(!empty($match[3][$i])){
                                        $extracted_img=$match[3][$i];
                                    }else{
                                        $extracted_img='';
                                    }
									$imginfo=@getimagesize($extracted_img);
									if(($imginfo[0]>=$min_width)&&($imginfo[1]>=$min_height)){
										$ret['image']=$extracted_img;
										$ret['width']=$imginfo[0];
										$ret['height']=$imginfo[1];
										break;
									}
                                }
							}
						}
						if($ret['image']==$no_img){
							if(!empty($rss_load_data[$feed_article_page]['content'])){
								if(preg_match_all('#(http[^\s]*\.(jpg|jpeg|gif|png|bmp))|<img src="(.*?)"#',$rss_load_data[$feed_article_page]['content'],$match)){
									for($i=0;$i<count($match[0]);$i++){
                                        if(!empty($match[1][$i])){
                                            $extracted_img=$match[1][$i];
                                        }elseif(!empty($match[3][$i])){
                                            $extracted_img=$match[3][$i];
                                        }else{
                                            $extracted_img='';
                                        }
                                        $imginfo=@getimagesize($extracted_img);
                                        if(($imginfo[0]>=$min_width)&&($imginfo[1]>=$min_height)){
                                            $ret['image']=$extracted_img;
                                            $ret['width']=$imginfo[0];
                                            $ret['height']=$imginfo[1];
                                            break;
                                        }
                                    }
								}
							}
						}
					}
				}
			}
		}
		if(!isset($ret)){
			$ret=false;
		}
		return $ret;
	}
	function getResizeValue($origin_width,$origin_height,$view_width,$view_heigh){
	/*-------------------------------------------------------------------
	-- 機能 --
	画像を指定サイズに収まるようにトリミングとリサイズをする値を返す。
	-- バージョン --
	v1.00
	-- 動作環境 --
	PHP 5
	-- 引数 --
	$origin_width	:画像の元サイズ 幅
	$origin_height	:画像の元サイズ 高さ
	$view_width		:指定サイズ 幅
	$view_heigh		:指定サイズ 高さ
	-- 返り値 --
	リサイズ+トリミング用の値を配列で返します。失敗した場合にfalseを返します。
	 =配列の内容=
	   $array('width',	リサイズした 幅
			  'height',	リサイズした 高さ
			  'left'	配置位置 左
			  'top')	配置位置 上
				  
	-- 更新履歴 --
	2014.12.03 制作 LOGICRAFT T.Y
	-------------------------------------------------------------------*/
		try{
			$origin_width=intval($origin_width);
			$origin_height=intval($origin_height);
			$view_width=intval($view_width);
			$view_heigh=intval($view_heigh);
			if($origin_width>0&&$origin_height>0&&$view_width>0&&$view_heigh>0){
				$basesizeRatio=$view_heigh/$view_width;
				$sizeRatio=$origin_height/$origin_width;
				if ($basesizeRatio <= $sizeRatio) {
					$resizeX=$view_width;
					$resizeY=$origin_height*($view_width/$origin_width);
				} else {
					$resizeY=$view_heigh;
					$resizeX=$origin_width*($view_heigh/$origin_height);
				}
				$ret['width']=round($resizeX);
				$ret['height']=round($resizeY);
				$ret['left']=(0-round(($resizeX-$view_width)/2));
				$ret['top']=(0-round(($resizeY-$view_heigh)/2));
				if($ret['width']<=0||$ret['height']<=0){
					$ret=false;
				}
			}else{
				$ret=false;
			}
		}catch(Exception $e){
			$ret=false;
		}
		return $ret;
	}
	function getEncodoType($data){
		$encodoArray = array();
		$encodoArray[]="SJIS";
		$encodoArray[]="SJIS-win";
		$encodoArray[]="EUC-JP";
		$encodoArray[]="eucJP-win";
		$encodoArray[]="CP51932";
		$encodoArray[]="JIS";
		$encodoArray[]="ISO-2022-JP";
		$encodoArray[]="ISO-2022-JP-MS";
		$encodoArray[]="UTF-8";
		$encodoArray[]="ASCII";
		foreach($encodoArray as $value){
			if(mb_check_encoding($data,$value)){
				break;
			}
		}
		return $value;
	}
	function searchStringfromURL($url,$encode,$seaString){
		$buffer="";
		$v_html="";
		$sea_flag=false;
		if(empty($encode)){
			$encode="UTF-8";
		}
		if(empty($seaString)){
			$seaString=false;
		}else{
            $seaString=rtrim($seaString,'/');
        }
		if($fp = @fopen($url, 'r')){
			while(!feof($fp)){
				$buffer=fgets($fp);
				$v_html.=mb_convert_encoding($buffer,$encode,getEncodoType($buffer));
				if($seaString==false){
					$sea_flag=true;
				}elseif(strpos($buffer,$seaString)!==false){
					$sea_flag=true;
				}
			}
			fclose($fp);
		}
		if(empty($seaString)){
			if(empty($v_html)){
				return false;
			}else{
				return $v_html;
			}
		}else{
			return $sea_flag;
		}
	}
	function load_log1($file_path,$type=''){
		if(file_exists($file_path)){
			$fp=@fopen($file_path,"r");
			if(!$fp){$err_str='open err '.$file_path;}else{
				while(!feof($fp)){
					$temp = fgets($fp);
					if($temp!="")$buff[]=$temp;
				}fclose($fp);
			}
		}$i=0;
		if(isset($buff) && count($buff)>0){
			foreach($buff as $value){
				if($type=='html'){
					$value=str_replace("&lt;",'<',$value);
					$value=str_replace("&gt;",'>',$value);
					$value=str_replace("&quot;",'"',$value);
					$value=str_replace("&amp;",'&',$value);
				}$log_put[$i]=$value;$i++;
			}
		}return $log_put;
	}
	function authentication_question_generator($int_answer){
		$str_question='';
		$image_root_path='./image/';
		$image_filename='';
		$image_width=25;
		$image_height=25;
		$image_firstname=0;
		$image_secondname=0;
		$int_answer_length= mb_strlen((string)$int_answer);
		for($n=0;$n<$int_answer_length;$n++){
			$image_filename=$image_root_path;
			$image_firstname=floor(mt_rand(0,6));
			if($image_firstname>5){$image_firstname=5;}
			$image_secondname=substr((string)$int_answer,$n,1);
			switch($image_firstname){
				case 0:$image_filename.='a_';break;
				case 1:$image_filename.='b_';break;
				case 2:$image_filename.='c_';break;
				case 3:$image_filename.='d_';break;
				case 4:$image_filename.='e_';break;
				default:$image_filename.='f_';
			}
			switch($image_secondname){
				case 0:$image_filename.='a.png';break;
				case 1:$image_filename.='b.png';break;
				case 2:$image_filename.='c.png';break;
				case 3:$image_filename.='d.png';break;
				case 4:$image_filename.='e.png';break;
				case 5:$image_filename.='f.png';break;
				case 6:$image_filename.='g.png';break;
				case 7:$image_filename.='h.png';break;
				case 8:$image_filename.='i.png';break;
				default:$image_filename.='j.png';
			}
			$str_question.='<img src="'.$image_filename.'" width="'.$image_width.'" height="'.$image_height.'" border="0" />';
		}
		return $str_question;
	}
	function exdemand($demand=''){
		$return_value=false;
		if($demand=='registration'){
			$return_value='登録';
		}elseif($demand=='modification'){
			$return_value='修正';
		}elseif($demand=='deletion'){
			$return_value='削除';
		}
		return $return_value;
	}
	function makeLinkPage(){
	/*-------------------------------------------------------------------
	-- 機能 --
	リンクページを生成する。
	-- バージョン --
	v1.01
	-- 動作環境 --
	PHP 5
	-- 引数 --
	-- 返り値 --
	成功した場合にtrue、失敗した場合にfalseを返します。
	-- 更新履歴 --
	2014.12.03 制作 LOGICRAFT T.Y
	2015.02.08 更新 LOGICRAFT T.Y 順位の値がない場合、非表示になっていた不具合を修正
	-------------------------------------------------------------------*/
		$ret=true;
		try{
            $countin_farst_flag=false;
            $countin_second_flag=false;
            $countin_third_flag=false;
			$SettingData=loadSetting();
			$LinkData=arrayGetCsv(LINK_LIST_FILE,22);
            /* -------------------------------
             column key
                0 :	rss			RSSアドレス
                1 :	crawl		RSS巡回・表示 0=しない 1=する(画像有) 2=する(画像なし)
                2 :	place		RSS記事の表示箇所 初期=0
                3 :	rank		リンク表示順位 0=非表示 値なし=最下位 昇順
                4 :	update		RSS取得日時 unixタイムスタンプ （最後に巡回した日時）
                5 :	url			サイトURL
                6 :	email		email
                7 :	password	パスワード
                8 :	sitename	サイト名
                9 :	introduct	紹介文
                10:	bannerurl	バナー画像 URL
                11:	bannerw		バナー画像 横幅
                12:	bannerh		バナー画像 縦幅
                13:	linkedurl	自サイトリンク登録先URL
                14:	link		記事URL
                15:	title		記事タイトル
                16:	pubDate		記事の日時
                17:	img			記事の画像 URL
                18:	imgw		記事の画像 横幅
                19:	imgh		記事の画像 縦幅
                20:	replace		置換文字
                21:	rock		順位固定 0=固定しない 1=固定する
                22:	access		アクセス数
            --------------------------------*/
			if($LinkData){
				$row=count($LinkData);
				foreach($LinkData as $key => $sort_data_value){
                    if(!empty($sort_data_value[3])){
                        $sort_rnk[$key] = $sort_data_value[3];
                    }else{
                        $sort_rnk[$key] = 65535;
                    }
					if(!empty($sort_data_value[14])){
						$sort_f_a[$key] = 1;
					}else{
						$sort_f_a[$key] = 0;
					}
					if(!empty($sort_data_value[17])&&$sort_data_value[17]!=$SettingData[0][12]){
						$sort_f_b[$key] = 1;
					}else{
						$sort_f_b[$key] = 0;
					}
				}
				if($SettingData[0][16]==2){
					if(($SettingData[0][17]==2)&&($SettingData[0][18]==2)){
						array_multisort($sort_f_a,SORT_DESC,$sort_f_b,SORT_DESC,$sort_rnk,SORT_ASC,$LinkData);
					}elseif($SettingData[0][17]==2){
						array_multisort($sort_f_a,SORT_DESC,$sort_rnk,SORT_ASC,$LinkData);
					}elseif($SettingData[0][18]==2){
						array_multisort($sort_f_b,SORT_DESC,$sort_rnk,SORT_ASC,$LinkData);
					}else{
						array_multisort($sort_rnk,SORT_ASC,$LinkData);
					}
				}else{
					array_multisort($sort_rnk,SORT_ASC,$LinkData);
				}
				$box_width=exchange_char($SettingData[0][2],"HTML")-4;
				$box_height=exchange_char($SettingData[0][3],"HTML")-4;
				if(preg_match('/#[a-fA-F0-9]{6}/',$SettingData[0][15])){
					$origin_color['red']=hexdec(substr($SettingData[0][15],1,2));
					$origin_color['green']=hexdec(substr($SettingData[0][15],3,2));
					$origin_color['blue']=hexdec(substr($SettingData[0][15],5,2));
					$color='rgba('.$origin_color['red'].','.$origin_color['green'].','.$origin_color['blue'].',0.5)';
					foreach($origin_color as &$value){
						$value=$value+83;
						if($value>255){
							$value=255;
						}
					}
					$bg_color='rgba('.$origin_color['red'].','.$origin_color['green'].','.$origin_color['blue'].',0.5)';
				}else{
					$color='rgba(0,0,0,0,0.5)';
				}
                $Buffer=null;
				if($SettingData[0][24]==1){
                    $Buffer.='<link href="'.$SettingData[0][20].'" rel="stylesheet" type="text/css">'."\n";
				}
                $Buffer.='<div class="quicklinker_body">'."\n";
                if($SettingData[0][16]==3){
                    $Buffer.='  <ul>'."\n";
                }
                $Buffer_second='<div class="ql_second_body">'."\n";
                $Buffer_second.='  <ul>'."\n";
                $Buffer_third='<div class="ql_third_body">'."\n";
                $Buffer_third.='  <ul>'."\n";
				$link_count=0;
                $not_count=0;
				$n=1;
				foreach($LinkData as $value){
                    if(($value[3]==='0')||($value[3]===0)){
                        $rank=0;
                    }elseif($row<(int)$value[3]){
                        $rank=100000+(int)$value[3];
                    }elseif(!empty($value[3])){
                        $rank=(int)$value[3];
                    }else{
                        $rank=1000000;
                    }
                    $url=exchange_char($value[5],"HTML");
                    $sitename=exchange_char($value[8],"HTML");
                    $introduct=exchange_char($value[9],"HTML");
                    $bannerurl=exchange_char($value[10],"HTML");
                    if(!empty($value[11])){
                        $bannerw=exchange_char($value[11],"HTML");
                    }else{
                        $bannerw=0;
                    }
                    if(!empty($value[12])){
                        $bannerh=exchange_char($value[12],"HTML");
                    }else{
                        $bannerh=0;
                    }
                    if(!empty($value[14])){
                        $link=exchange_char($value[14],"HTML");
                        $b_link=$link;
                    }else{
                        $link=$url;
                        $b_link='';
                    }
                    $title=exchange_char($value[15],"HTML");
                    if(!empty($value[16])){
                        $pubDate=date('Y/m/d H:i',strtotime(exchange_char($value[16],"HTML")));
                    }else{
                        $pubDate=0;
                    }
                    $img=exchange_char($value[17],"HTML");
                    if(!empty($value[18])){
                        $imgw=exchange_char($value[18],"HTML");
                    }else{
                        $imgw=0;
                    }
                    if(!empty($value[19])){
                        $imgh=exchange_char($value[19],"HTML");
                    }else{
                        $imgh=0;
                    }
                    if(empty($link)||$imgw<=0||$imgh<=0){
                        if(!empty($bannerurl)){
                            $img=$bannerurl;
                            $imgw=$bannerw;
                            $imgh=$bannerh;
                        }elseif(!empty($SettingData[0][12])){
                            $img=exchange_char($SettingData[0][12],"HTML");
                            $imgw=exchange_char($SettingData[0][13],"HTML");
                            $imgh=exchange_char($SettingData[0][14],"HTML");
                        }
                    }
					if($SettingData[0][19]>$link_count){
                        if($rank>0){
                            if((($rank<=$row)&&($value[21]==1))||
                               ($value[22]>=$SettingData[0][27])||
                               ($SettingData[0][27]<=0)){
                                //バナーあり
                                if($SettingData[0][16]==1){
                                    $Buffer.='  <div class="quicklinker_link_article" style="background-color:'.$bg_color.';width:'.$box_width.'px; height:'.$box_height.'px;">'."\n";
                                    if($imgvalue=getResizeValue($bannerw,$bannerh,$box_width,$box_height)){
                                        $Buffer.='    <a href="'.$url.'" title="'.$introduct.'" target="_blank"><img class="img" border="0" style="top:'.$imgvalue['top'].'px; left:'.$imgvalue['left'].'px;" src="'.$bannerurl.'" width="'.$imgvalue['width'].'" height="'.$imgvalue['height'].'" alt="'.$sitename.'"></a>'."\n";
                                    }else{
                                        $Buffer.='    <a href="'.$url.'" title="'.$introduct.'" target="_blank"><div class="img" style="width:'.$box_width.'px; height:'.$box_height.'px;"></div></a>'."\n";
                                    }
                                    $Buffer.='    <div class="other" style="background-color:'.$color.';width:'.$box_width.'px;">'."\n";
                                    $Buffer.='      <a class="sitename" href="'.$url.'" title="'.$introduct.'" target="_blank">'.$sitename.'</a>'."\n";
                                    $Buffer.='    </div>'."\n";
                                    $Buffer.='  </div>'."\n";
                                    $link_count++;
                                    $countin_farst_flag=true;
                                //RSSフィード
                                }elseif($SettingData[0][16]==2){
                                    if(($SettingData[0][17]!=0)||!empty($b_link)){
                                        if(($SettingData[0][18]!=0)||(!empty($img)&&$img!=$SettingData[0][12])){
                                            $Buffer.='  <div class="quicklinker_link_article" style="background-color:'.$bg_color.';width:'.$box_width.'px; height:'.$box_height.'px;">'."\n";
                                            if($imgvalue=getResizeValue($imgw,$imgh,$box_width,$box_height)){
                                                $Buffer.='    <a href="'.$link.'" title="'.$title.'" target="_blank"><img class="img" border="0" class="thumb" style="top:'.$imgvalue['top'].'px; left:'.$imgvalue['left'].'px;" src="'.$img.'" width="'.$imgvalue['width'].'" height="'.$imgvalue['height'].'" alt="'.$title.'"></a>'."\n";
                                            }else{
                                                $Buffer.='    <a href="'.$link.'" title="'.$title.'" target="_blank"><div class="img" style="width:'.$box_width.'px; height:'.$box_height.'px;"></div></a>'."\n";
                                            }
                                            $Buffer.='    <div class="other" style="background-color:'.$color.';width:'.$box_width.'px;">'."\n";
                                            if($SettingData[0][22]!=0){
                                                $Buffer.='		<a class="title" href="'.$link.'" title="'.$title.'" target="_blank">'.mb_strimwidth($title,0,$SettingData[0][23],'..','utf-8').'</a>';
                                            }
                                            if($SettingData[0][21]!=0){
                                                $Buffer.='      <a class="sitename" href="'.$url.'" title="'.$introduct.'" target="_blank">'.$sitename.'</a>'."\n";
                                            }
                                            $Buffer.='    </div>'."\n";
                                            $Buffer.='  </div>'."\n";
                                            $link_count++;
                                            $countin_farst_flag=true;
                                        }
                                    }
                                //RSSフィード（テキストのみ）
                                }elseif($SettingData[0][16]==3){
                                    if(!empty($title)){
                                        $Buffer.='    <li><a href="'.$link.'" title="'.$title.'" target="_blank">'.$title.' / '.$sitename.'</a></li>'."\n";
                                        $link_count++;
                                        $countin_farst_flag=true;
                                    }
                                //バナーなし
                                }else{
                                    $Buffer.='  <div class="quicklinker_link_article" style="background-color:'.$bg_color.';width:'.$box_width.'px;height:36px;">'."\n";
                                    $Buffer.='    <div class="other" style="background-color:'.$color.';width:'.$box_width.'px;height:36px;">'."\n";
                                    $Buffer.='      <a class="sitename" href="'.$url.'" title="'.$introduct.'" target="_blank">'.$sitename.'</a>'."\n";
                                    $Buffer.='    </div>'."\n";
                                    $Buffer.='  </div>'."\n";
                                    $link_count++;
                                    $countin_farst_flag=true;
                                }
                                //非表示になったものをピックアップ
                                if($not_count==$link_count){
                                    if(!empty($title)){
                                        $Buffer_second.='    <li><a href="'.$link.'" title="'.$title.'" target="_blank">'.$title.' / '.$sitename.'</a></li>'."\n";
                                        $countin_second_flag=true;
                                    }
                                }
                            }
                        }
                        $not_count=$link_count;
                    }else{
                        if($rank>0){
                            if((($rank<=$row)&&($value[21]==1))||
                               ($value[22]>=$SettingData[0][27])||
                               ($SettingData[0][27]<=0)){
                                if(!empty($title)){
                                    $Buffer_second.='    <li><a href="'.$link.'" title="'.$title.'" target="_blank">'.$title.' / '.$sitename.'</a></li>'."\n";
                                    $countin_second_flag=true;
                                }
                            }
                        }
					}
                    if($rank>0){
                        if((($rank<=$row)&&($value[21]==1))||
                           ($value[22]>=$SettingData[0][27])||
                           ($SettingData[0][27]<=0)){
                            $Buffer_third.='    <li><a href="'.$url.'" title="'.$introduct.'" target="_blank">'.$sitename.'</a></li>'."\n";
                            $countin_third_flag=true;
                        }
                    }
				}
				if($SettingData[0][16]==3){
                    $Buffer.='  </ul>'."\n";
                }
                if($countin_farst_flag==true){
                    $Buffer.=POWERD_BY;
				}
                $Buffer.='</div>'."\n";
				file_put_contents(LINK_PAGE_FILE1, $Buffer, LOCK_EX);
                $Buffer_second.='  </ul>'."\n";
                if($countin_second_flag==true){
                    $Buffer_second.=POWERD_BY;
                }
                $Buffer_second.='</div>'."\n";
				file_put_contents(LINK_PAGE_FILE2, $Buffer_second, LOCK_EX);
                $Buffer_third.='  </ul>'."\n";
                if($countin_third_flag==true){
                    //$Buffer_third.=POWERD_BY;
                }
                $Buffer_third.='</div>'."\n";
				file_put_contents(LINK_PAGE_FILE3, $Buffer_third, LOCK_EX);
			}else{
				$ret=false;
			}
		}catch(Exception $e){
			$ret=false;
		}
		return $ret;
	}
    function checkSettingValue(&$setting_array,&$err_msg,$fix_flag=false){
	/*-------------------------------------------------------------------
	-- 機能 --
	設置用の値に異常がないかチェックする。
	-- バージョン --
	v1.00
	-- 動作環境 --
	PHP 5
	-- 引数 --
    $setting_array  :設定用値の一次元配列 setDefaultValueを参照...
    $err_msg        :エラーメッセージ
    $fix_flag       :値に異常がある場合の修正フラグ false=修正しない true=異常のある箇所に初期値を入れる
	-- 返り値 --
	異常がない場合、true。
    異常がある場合、falseを返す。
	-- 更新履歴 --
	2015.01.27 制作 LOGICRAFT T.Y
        0	:	ドメイン
        1	:	管理者メール
        2	:	バナー画像 横幅 x
        3	:	バナー画像 縦幅 y
        4	:	url
        5	:	パスワード
        6	:	サイト名
        7	:	rss
        8	:	RSSフィード取得 1回あたりにかける時間（min）
        9	:	RSSフィード取得 1回あたりの最大取得件数
        10	:	RSSフィード取得 最低画像サイズ 横幅 x
        11	:	RSSフィード取得 最低画像サイズ 縦幅 y
        12	:	RSSフィード取得 画像なしの場合、差し替え画像
        13	:	RSSフィード取得 差し替え画像 横幅 x
        14	:	RSSフィード取得 差し替え画像 縦幅 y
        15	:	背景色
        16	:	リンク表示 0=バナーなし 1=バナーあり 2=RSS
        17	:	RSSフィードがない場合 0=非表示 1=表示 2=順位を下げて表示
        18	:	RSSフィードに画像がない場合 0=非表示 1=表示 2=順位を下げて表示
        19	:	最大リンク表示件数
        20	:	CSSURL
        21  :   サイト名の表示 0=非表示 1=表示
        22  :   記事タイトルの表示 0=非表示 1=表示
        23  :   文字の最大表示数
        24  :   CSS添付 0=添付しない 1=添付する
        25  :   RSSの項目表示 0=表示 1=非表示
        26  :   バナーURLの項目表示 0=表示 1=非表示
        27  :   逆アクセス数が指定数を下回るものは非表示 0=全て表示 1~=規制あり
	-------------------------------------------------------------------*/
        $result=true;
        $err_msg=null;
        $fix_value=setDefaultValue();
        $keys=array(2,3,8,9,10,11,13,14,16,17,18,19,21,22,23,24,25,26,27);
        foreach($keys as $key){
            if($setting_array[$key]===false){
                $setting_array[$key]=0;
            }
            if(!is_numeric($setting_array[$key])){
                $result=false;
                $err_msg.='error: '.$key.' - not number value'."\n";
                if($fix_flag==true){
                    $setting_array[$key]=$fix_value[$key];
                }
            }
        }
        $keys=array(4,20);
        foreach($keys as $key){
            if(!preg_match('/^https?:\/\//',$setting_array[$key])){
                $result=false;
                $err_msg.='error: '.$key.' - not url value'."\n";
                if($fix_flag==true){
                    $setting_array[$key]=$fix_value[$key];
                }
            }
        }
        $keys=array(15);
        foreach($keys as $key){
            if(!preg_match('/^#[a-fA-F0-9]{6}$/',$setting_array[$key])){
                $result=false;
                $err_msg.='error: '.$key.' - not rgb color value'."\n";
                if($fix_flag==true){
                    $setting_array[$key]=$fix_value[$key];
                }
            }
        }
        $key=5;
        $count_num=mb_strlen($setting_array[$key],'utf-8');
        if(!(($count_num>=4) && ($count_num<=8))){
            $result=false;
            $err_msg.='error: '.$key.' - not the specified number of digits'."\n";
            if($fix_flag==true){
                $setting_array[$key]=$fix_value[$key];
            }
        }
        $keys=array(8,9,19,23);
        foreach($keys as $key){
            if(!(($setting_array[$key]>=1) && ($setting_array[$key]<=999))){
                $result=false;
                $err_msg.='error: '.$key.' - not the specified number of digits'."\n";
                if($fix_flag==true){
                    $setting_array[$key]=$fix_value[$key];
                }
            }
        }
        $keys=array(2,3,10,11,13,14);
        foreach($keys as $key){
            if(!(($setting_array[$key]>=0) && ($setting_array[$key]<=9999))){
                $result=false;
                $err_msg.='error: '.$key.' - not the specified number of digits'."\n";
                if($fix_flag==true){
                    $setting_array[$key]=$fix_value[$key];
                }
            }
        }
        return $result;
    }
    function setDefaultValue($no_data_img_path=NO_DATA_IMG_PATH,$no_data_img_width=NO_DATA_IMG_WIDTH,$no_data_img_height=NO_DATA_IMG_HEIGHT){
	/*-------------------------------------------------------------------
	-- 機能 --
	設置用の値の初期値をセットする。
	-- バージョン --
	v1.00
	-- 動作環境 --
	PHP 5
	-- 引数 --
    $no_data_img_path   :画像ない場合用の代替え画像 urlパス
    $no_data_img_width  :画像ない場合用の代替え画像 横幅
    $no_data_img_height :画像ない場合用の代替え画像 高さ
	-- 返り値 --
	下記の値をArrayで返す。
        column
        0	:	ドメイン
        1	:	管理者メール
        2	:	バナー画像 横幅 x
        3	:	バナー画像 縦幅 y
        4	:	url
        5	:	パスワード 4~8桁
        6	:	サイト名
        7	:	rss
        8	:	RSSフィード取得 1回あたりにかける時間（min） 1-
        9	:	RSSフィード取得 1回あたりの最大取得件数 1-
        10	:	RSSフィード取得 最低画像サイズ 横幅 x
        11	:	RSSフィード取得 最低画像サイズ 縦幅 y
        12	:	RSSフィード取得 画像なしの場合、差し替え画像
        13	:	RSSフィード取得 差し替え画像 横幅 x
        14	:	RSSフィード取得 差し替え画像 縦幅 y
        15	:	背景色
        16	:	リンク表示 0=バナーなし 1=バナーあり 2=RSS
        17	:	RSSフィードがない場合 0=非表示 1=表示 2=順位を下げて表示
        18	:	RSSフィードに画像がない場合 0=非表示 1=表示 2=順位を下げて表示
        19	:	最大リンク表示件数 1-
        20	:	CSSURL
        21  :   サイト名の表示 0=非表示 1=表示
        22  :   記事タイトルの表示 0=非表示 1=表示
        23  :   文字の最大表示数 1-
        24  :   CSS添付 0=添付しない 1=添付する
        25  :   RSSの項目表示 0=表示 1=非表示
        26  :   バナーURLの項目表示 0=表示 1=非表示
        27  :   逆アクセス数が指定数を下回るものは非表示 0=全て表示 1~=規制あり
	-- 更新履歴 --
	2015.01.27 制作 LOGICRAFT T.Y
	-------------------------------------------------------------------*/
        $my_url=$_SERVER["HTTP_HOST"];
        if(isset($_SERVER['HTTPS']) && ($_SERVER['HTTPS'] == 'on'))
        {
            $my_url='https://'.$my_url;
        }else{
            $my_url='http://'.$my_url;
        }
        $my_cssurl=$my_url.dirname($_SERVER["REQUEST_URI"]).'/quicklinker.css';
        $my_url.='/';
        $result=array($_SERVER["SERVER_NAME"],
                             '',
                             180,
                             150,
                             $my_url,
                             '1234',
                             '',
                             '',
                             20,
                             20,
                             125,
                             125,
                             $no_data_img_path,
                             $no_data_img_width,
                             $no_data_img_height,
                             '#505050',
                             0,
                             1,
                             1,
                             100,
                             $my_cssurl,
                             1,
                             0,
                             50,
                             1,
                             0,
                             0,
                             0,
                             0);
        return $result;
    }
	function loadSetting($setup_file=SETUP_FILE){
	/*-------------------------------------------------------------------
	-- 機能 --
	設定用の値をロードする。
    初期の場合は初期値を返す。
	-- バージョン --
	v1.00
	-- 動作環境 --
	PHP 5
	-- 引数 --
    $setup_file :設定用ファイルパス
	-- 返り値 --
	設定用の値を二次元配列で返す。 array[0][*] *に各設定値が格納される。
	-- 更新履歴 --
	2015.01.27 制作 LOGICRAFT T.Y
	-------------------------------------------------------------------*/
		$settingData=false;
		if(file_exists($setup_file)){
			$settingData=arrayGetCsv($setup_file,27);
		}else{
			$settingData[]=setDefaultValue();
		}
		return $settingData;
	}